#
# spec file for package mined (Version 2000.12.2)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db desktop-translations diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip update-desktop-files util-linux vim zlib zlib-devel

Name:           mined
BuildRequires:  update-desktop-files
License:        Other License(s), see package, GPL
Group:          Productivity/Editors/Other
Autoreqprov:    on
Version:        2000.12.2
Release:        0.1
URL:            http://towo.net/mined/
Source0:        http://towo.net/mined/mined-2000.12.2.tar.bz2
Patch1:         mined.desktop.patch
Patch2:         build.patch
Patch10:        mined2000-termio.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Summary:        Powerful Text Editor with Extensive Unicode and CJK Support

%description
Mined is a powerful text editor with a comprehensive and easy-to-use
user interface and fast, small-footprint behavior.

It was the first editor that provided Unicode support in a plain-text
terminal. It now has both extensive Unicode and CJK support offering
many specific features and covering special cases that other editors
are not aware of (like autodetection features and automatic handling of
terminal variations or Han character information). Basically, it is an
editor tailored to efficient editing of plain text documents and
programs with features and interactive behavior designed for this
purpose.

Mined Overview

Good interactive features * Intuitive user interface

* Logical and consistent concept of navigating and editing text
   (without ancient line-end handling limitations or insert or
   append confusion)

* Supports various control styles: Editing with command control,
   function key control, or menu control Navigation by cursor keys,
   control keys, mouse or scrollbar

* Comprehensive menus (driven by keyboard or mouse)

* "HOP" key paradigm doubles the number of navigation functions that
   can be most easily reached and remembered by intuitively
   amplifying the associated function

* Immediate adjustment if the window size is changed in any state of
   interaction

Versatile character encoding support * Extensive Unicode support,
   including double-width and combining characters, script
   highlighting, various methods of character input support (mapped
   keyboard input methods, mnemonic and numeric input), supporting
   CJK, Vietnamese, Hebrew, Arabic, and other scripts

* Support of bidirectional terminals, Arabic ligature joining

* East Asian character set support: handling of major CJK encodings
   (including GB18030 and full EUC-JP with combining characters) in
   either Unicode terminal or CJK terminal

* Support for a variety of 8-bit encodings (mapped to Unicode) (with
   combining characters for Vietnamese and Thai)

* Support of CJK input methods by enhanced keyboard mapping
   including multiple choice mappings (handled by a pick list menu);
   characters in the pick list being sorted by relevance of Unicode
   ranges

* Han character information with description and pronunciation

* Autodetection of text character encoding, edit of files with mixed
   character encoding sections (such as mailboxes), transparent
   handling of UTF-16 encoded files

* Autodetection of UTF-8 and CJK terminal mode and detailed features
   (like different Unicode width and combining data versions)

* Encoding support tested with: xterm, mlterm, hanterm, cxterm,
   rxvt, linux console

Many useful text editing capabilities * Many text editing features,
   such as paragraph wrapping, autoindentation and back-tab, smart
   quotes (with quotation marks style selection and autodetection),
   and smart dashes

* Search and replacement patterns can have multiple lines

* Cross-session paste buffer (copy and paste between multiple--even
   subsequent or remote--invocations of mined)

* Marker stack for quick return to previous text positions

* Multiple paste buffers (emacs-style)

* Program editing features, HTML support and syntax highlighting,
   identifier and function definition search, also across files;
   structure input support

* Text and program layout features; autoindentation and undent
   function (back-tab), numbered item justification

* Systematic text and file handling safety, avoiding loss of data

* Visible indications of special text contents (TAB characters,
   different line-end types, character codes that cannot be
   displayed in the current mode)

* Full binary transparent editing with visible indications (illegal
   UTF-8 or CJK, mixed line end types, NUL characters, etc.)

* Print function that works in all text encodings

* Optional emacs command mode

Small-footprint operation and portability * Plain text mode
   (terminal) operation, supporting wide range of terminals

* Instant start-up

* Runs on many platforms: Unix (Linux/Sun/HP/BSD/Mac and more), DOS
   (djgpp), Windows (cygwin)

* Makefiles also support legacy systems



Authors:
--------
    Thomas Wolff <mined@towo.net>

%debug_package
%prep
%setup0 -q -n mined-2000.12.2
%patch1 -p1
%patch2 -p1

%build
make OPT="$RPM_OPT_FLAGS -fno-strict-aliasing" -C src -f makefile.linux LIBDIR=%{_libdir}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
make INSTALLROOT=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}
for i in $RPM_BUILD_ROOT/%{_datadir}/mined/*
do
       ln -sf ${i##${RPM_BUILD_ROOT}} \
              $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}/
done
%suse_update_desktop_file -i %name ConsoleOnly TextEditor

%clean
#[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-, root, root)
%doc %{_defaultdocdir}/%{name}/
%{_bindir}/*
%{_mandir}/man1/*.1*
%dir %{_datadir}/mined/
%{_datadir}/mined/*
%if %suse_version > 820
/usr/share/applications/%name.desktop
%endif

%changelog -n mined
* Tue Jul 11 2006 - mfabian@suse.de
- update to mined 2000.12.2.
  + Updated to Unicode 5.0.0 beta2
  + Supplemented Big5 character set with HKSCS-2004 update
  + Revised interpretation of locale environment variables
  + Revised terminal encoding handling
  + Supporting lots of additional 8-bit encodings
  + Optional Unicode Copy/Paste buffer mode with implicit conversion
  + Supplemented Cangjie input method with additional mappings from
  HKSCS-2004
  + Case conversion is now always (i.e. in all encodings) based on
  Unicode.
  + Smart quotes enabled in all text encodings.
  + Updated HTML character mnemonics to HTML 4.01.
  + Interworking enhancements: Improved intuitive assignment of
  copy/paste functions to keypad, enhanced flexbility of usage.
  + Further improvements on terminal interworking (even
  version-specific), especially with KDE konsole.
  See also http://bugzilla.novell.com/show_bug.cgi?id=161746
  + Added kterm encoding auto-detection.
- remove hunks from build.patch which are included upstream
- remove do-not-return-random-data-in-function.patch (included
  upstream).
* Wed May 17 2006 - schwab@suse.de
- Don't strip binaries.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Aug 05 2005 - mfabian@suse.de
- update to 2000.11 (updated to Unicode 4.1.0).
* Wed Jun 15 2005 - meissner@suse.de
- use RPM_OPT_FLAGS -fno-strict-aliasing.
- fixed a harmless buffer overflow.
* Wed Mar 02 2005 - mfabian@suse.de
- add another patch from author to improve menu-frames when
  using konsole.
* Tue Mar 01 2005 - mfabian@suse.de
- add patch from author to fix the following bugs:
  o  Fixed missing use of terminal capability to "enable alternate
  character set" (terminfo enacs, termcap eA) so graphic menu
  borders should now work in some remaining cases and no longer be
  replaced with letters.
  o Fixed partial scrollbar update logic to prevent gaps in
  scrollbar display.
  o Tweaked panic handling to terminate more smoothly after a
  screen output error (e.g. if output crashes with ncursesw 5.4
  on a more than 3 bytes UTF-8 sequence).
* Fri Feb 04 2005 - mfabian@suse.de
- fix mined.desktop file and make it build for SuSE 8.2.
* Thu Feb 03 2005 - mfabian@suse.de
- update to 2000.10.
  extract from the author's announcement:
  o Character encoding, CJK, and input support enhancements
  +	Printing feature revamped; now working with all encodings.
  +	Updated character properties to Unicode 4.0.1:
  case conversion, character-to-script mapping, screen width
  (continuing to work with older width data versions by
  terminal auto-detection), keyboard mappings for CJK input
  methods (esp. updated Cangjie keyboard mapping table
  accordingly).
  +	Added support for major mapped 8 bit character encodings.
  +	Added transparent handling of UTF-16 encoded files
  (with BOM).
  +	Full support for combining characters in CJK encodings
  and 8 bit encodings, including optional separated display
  mode and partial editing (within combined character).
  +	Added Han character information
  (description / pronunciation) while browsing text or
  input method pick lists.
  +	Enhanced character information conforming to ISO 14755.
  +	Added keyboard mapping features and added important
  input methods to the default configuration as part of
  the distribution.
  +	Additional input support for CJK, Vietnamese, Thai, Hebrew.
  +	Added radical/stroke lookup input method for CJK characters,
  especially useful for not CJK speaking users.
  +	Revamped mnemonic input support; completed mnemonic patterns
  and enhanced documentation.
  +	Enhanced numeric character input support; conforming to
  ISO 14755.
  o Interactive enhancements
  +	Revamped menu control; added subtitles and flag markers
  (showing active options); enabled menu navigation by item
  letters or mouse wheel movement.
  o Runtime environment enhancements
  +	Enhanced interoperability with various terminals; enhanced
  detection and handling of available menu border styles as
  well as screen attributes used for scrollbar and special
  character display for a wide range of terminals.
  +	Providing runtime support library with X configuration
  patterns and terminal startup scripts.
* Thu May 06 2004 - hmacht@suse.de
- added norootforbuild in specfile
* Mon Mar 15 2004 - mfabian@suse.de
- update to 2000.9.
  extract from the author's announcement:
  + more compact representation for character set tables and
  keyboard mapping tables. Reduces size of binary more than 700K.
  + encoding autodetection improved
  + Position stack and return function also work across files
  (esp. after identifier definition searches using tags file)
  + Smart quotes: auto-detection of quotation marks style on file loading.
  + Interactive Latin-1 / UTF-8 conversion support.
  + Support for VIM keyboard mapping files.
- remove mined-64bit.patch (included upstream).
* Mon Aug 04 2003 - mfabian@suse.de
- update to 2000.8
  extract from the author's announcement:
  New features in this release:
  * Major extension of CJK character set support: GB18030,
  full EUC-JP, CNS (EUC-TW)
  * Vietnamese VISCII character set support
  * Auto-detection of UTF-8 / CJK terminal features
  * Flexible locale configuration for both text and terminal encoding
  * Smart dashes
  * Multiple paste buffers (emacs-style)
  * emacs command mode
  Main enhancements:
  * Revised Japanese input method tables
* Tue May 27 2003 - mfabian@suse.de
- update to 2000.7
  extract from the author's announcement:
  New features in this release:
  * Enhanced East Asian input method support;
  selection menu for multiple character choices ("pick list").
  * Support for editing CJK encoded files in UTF-8 terminal; major
  CJK encodings are supported (Big5, GBK, JIS, S-JIS, UHC, Johab).
  Main enhancements:
  * Flag menus for all flags for more intuitive selection.
  * Enhanced and generalized coded character input (CJK / decimal
  / illegal code recognition).
  * Extended bullet recognition for clever justification (auto-indent).
* Tue Mar 25 2003 - mfabian@suse.de
- update to 2000.6
  extract from the author's announcement:
  New features:
  * bidirectional terminal support handles Arabic ligature joining
  (LAM/ALEF)
  * new command to go backward and forward along text positions
  after search and other operations
  Main enhancements:
  * Added recognition of mouse wheel control sequences and attached
  according behaviour - untested as I don't have a mouse wheel.
  * New key interpretations for shift-Return (shift-Enter) and
  control-Return (control-Enter) to insert Unicode paragraph
  separators and line separators respectively if Unicode
  line-end handling is enabled.
  * Improved coded and mnemonic character entry on prompt line.
  * Fixed display problems in separated display mode
  (for Unicode combined characters) on the status line.
  * Reviewed various commands for remaining fixes in UTF-8 handling.
- remove errno patch (included upstream)
* Mon Jan 20 2003 - mfabian@suse.de
- update to 2000.5
* Mon Dec 02 2002 - ro@suse.de
- include errno.h where needed
* Tue Oct 01 2002 - mfabian@suse.de
- update to 2000.4
  extract from /usr/share/doc/packages/mined/CHANGES
  * Made use of advanced xterm mouse tracking modes.
  * Syntax highlighting
  * auto-indentation
  * Checkout and checkin functions for version management systems
  * Revised case conversion and other Unicode character
  property handling.
  * Fixed some display bugs
  * Fixed some search pattern match bugs
  * Removed restriction of regular expressions with Unicode
  characters
* Tue Aug 06 2002 - mfabian@suse.de
- update to 2000.3
  * updated man page and html documentation
  * some interface improvements and bug fixes
  for details see /usr/share/doc/packages/mined/CHANGES
* Sat Apr 21 2001 - mfabian@suse.de
- update tarball, which includes some fixes from the author:
  menu frames are now drawn with graphic characters even on the
  linux console, help file is automatically found in the standard
  location on SuSE Linux: /usr/share/doc/packages/mined/mined.hlp
* Fri Apr 20 2001 - mfabian@suse.de
- update to version 2000.2
- remove mined.dif and mined2000-termio.patch (fixes included
  upstream)
- remove mined.man (now included upstream)
* Thu Mar 22 2001 - mfabian@suse.de
- add termios/termio patch from werner@suse.de
- bzip2 sources
* Tue Mar 20 2001 - mfabian@suse.de
- use ncurses instead of termcap
* Mon Mar 05 2001 - mfabian@suse.de
- the fix by stepan@suse.de also makes it compile on ia64
* Thu Jan 25 2001 - stepan@suse.de
- prototype fixes for troublefree compilation on Alpha
* Sat Jan 13 2001 - mfabian@suse.de
- converted mined.help file to nroff to have a regular manpage
- updated to mined 2000
* Mon Jan 08 2001 - mfabian@suse.de
- new package: mined 98 release 5/99
